Blob


1 #!/bin/sh
2 #
3 # Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
4 #
5 # Permission to use, copy, modify, and distribute this software for any
6 # purpose with or without fee is hereby granted, provided that the above
7 # copyright notice and this permission notice appear in all copies.
8 #
9 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
17 . ./common.sh
19 test_commit_basic() {
20 local testroot=`test_init commit_basic`
22 got checkout $testroot/repo $testroot/wt > /dev/null
23 ret=$?
24 if [ $ret -ne 0 ]; then
25 test_done "$testroot" "$ret"
26 return 1
27 fi
29 echo "modified alpha" > $testroot/wt/alpha
30 (cd $testroot/wt && got rm beta >/dev/null)
31 echo "new file" > $testroot/wt/new
32 (cd $testroot/wt && got add new >/dev/null)
34 (cd $testroot/wt && got commit -m 'test commit_basic' > $testroot/stdout)
36 local head_rev=`git_show_head $testroot/repo`
37 echo "A new" > $testroot/stdout.expected
38 echo "M alpha" >> $testroot/stdout.expected
39 echo "D beta" >> $testroot/stdout.expected
40 echo "Created commit $head_rev" >> $testroot/stdout.expected
42 cmp -s $testroot/stdout.expected $testroot/stdout
43 ret=$?
44 if [ $ret -ne 0 ]; then
45 diff -u $testroot/stdout.expected $testroot/stdout
46 fi
47 test_done "$testroot" "$ret"
48 }
50 test_commit_new_subdir() {
51 local testroot=`test_init commit_new_subdir`
53 got checkout $testroot/repo $testroot/wt > /dev/null
54 ret=$?
55 if [ $ret -ne 0 ]; then
56 test_done "$testroot" "$ret"
57 return 1
58 fi
60 mkdir -p $testroot/wt/d
61 echo "new file" > $testroot/wt/d/new
62 echo "another new file" > $testroot/wt/d/new2
63 (cd $testroot/wt && got add d/new >/dev/null)
64 (cd $testroot/wt && got add d/new2 >/dev/null)
66 (cd $testroot/wt && \
67 got commit -m 'test commit_new_subdir' > $testroot/stdout)
69 local head_rev=`git_show_head $testroot/repo`
70 echo "A d/new" > $testroot/stdout.expected
71 echo "A d/new2" >> $testroot/stdout.expected
72 echo "Created commit $head_rev" >> $testroot/stdout.expected
74 cmp -s $testroot/stdout.expected $testroot/stdout
75 ret=$?
76 if [ $ret -ne 0 ]; then
77 diff -u $testroot/stdout.expected $testroot/stdout
78 fi
79 test_done "$testroot" "$ret"
80 }
82 test_commit_subdir() {
83 local testroot=`test_init commit_subdir`
85 got checkout $testroot/repo $testroot/wt > /dev/null
86 ret=$?
87 if [ $ret -ne 0 ]; then
88 test_done "$testroot" "$ret"
89 return 1
90 fi
92 echo "modified alpha" > $testroot/wt/alpha
93 echo "modified zeta" > $testroot/wt/epsilon/zeta
95 (cd $testroot/wt && \
96 got commit -m 'test commit_subdir' epsilon > $testroot/stdout)
98 local head_rev=`git_show_head $testroot/repo`
99 echo "M epsilon/zeta" >> $testroot/stdout.expected
100 echo "Created commit $head_rev" >> $testroot/stdout.expected
102 cmp -s $testroot/stdout.expected $testroot/stdout
103 ret=$?
104 if [ $ret -ne 0 ]; then
105 diff -u $testroot/stdout.expected $testroot/stdout
106 fi
107 test_done "$testroot" "$ret"
110 test_commit_single_file() {
111 local testroot=`test_init commit_single_file`
113 got checkout $testroot/repo $testroot/wt > /dev/null
114 ret=$?
115 if [ $ret -ne 0 ]; then
116 test_done "$testroot" "$ret"
117 return 1
118 fi
120 echo "modified alpha" > $testroot/wt/alpha
121 echo "modified zeta" > $testroot/wt/epsilon/zeta
123 (cd $testroot/wt && got commit -m 'changed zeta' epsilon/zeta \
124 > $testroot/stdout)
126 local head_rev=`git_show_head $testroot/repo`
127 echo "M epsilon/zeta" >> $testroot/stdout.expected
128 echo "Created commit $head_rev" >> $testroot/stdout.expected
130 cmp -s $testroot/stdout.expected $testroot/stdout
131 ret=$?
132 if [ $ret -ne 0 ]; then
133 diff -u $testroot/stdout.expected $testroot/stdout
134 fi
135 test_done "$testroot" "$ret"
138 test_commit_out_of_date() {
139 local testroot=`test_init commit_out_of_date`
140 local first_commit=`git_show_head $testroot/repo`
142 got checkout $testroot/repo $testroot/wt > /dev/null
143 ret=$?
144 if [ $ret -ne 0 ]; then
145 test_done "$testroot" "$ret"
146 return 1
147 fi
149 echo "modified alpha" > $testroot/repo/alpha
150 git_commit $testroot/repo -m "modified alpha"
152 echo "modified alpha" > $testroot/wt/alpha
154 (cd $testroot/wt && got commit -m 'test commit_out_of_date' \
155 > $testroot/stdout 2> $testroot/stderr)
157 echo -n > $testroot/stdout.expected
158 echo "got: work tree must be updated before these" \
159 "changes can be committed" > $testroot/stderr.expected
161 cmp -s $testroot/stdout.expected $testroot/stdout
162 ret=$?
163 if [ $ret -ne 0 ]; then
164 diff -u $testroot/stdout.expected $testroot/stdout
165 test_done "$testroot" "$ret"
166 return 1
167 fi
169 cmp -s $testroot/stderr.expected $testroot/stderr
170 ret=$?
171 if [ $ret -ne 0 ]; then
172 diff -u $testroot/stderr.expected $testroot/stderr
173 test_done "$testroot" "$ret"
174 return 1
175 fi
177 echo "alpha" > $testroot/repo/alpha
178 git_commit $testroot/repo -m "reset alpha contents"
179 (cd $testroot/wt && got update -c $first_commit > /dev/null)
181 echo "modified alpha" > $testroot/wt/alpha
183 (cd $testroot/wt && got commit -m 'changed alpha ' > $testroot/stdout)
184 ret=$?
185 if [ $ret -ne 0 ]; then
186 echo "commit failed unexpectedly" >&2
187 test_done "$testroot" "1"
188 return 1
189 fi
191 local head_rev=`git_show_head $testroot/repo`
192 echo "M alpha" > $testroot/stdout.expected
193 echo "Created commit $head_rev" >> $testroot/stdout.expected
194 cmp -s $testroot/stdout.expected $testroot/stdout
195 ret=$?
196 if [ $ret -ne 0 ]; then
197 diff -u $testroot/stdout.expected $testroot/stdout
198 fi
199 test_done "$testroot" "$ret"
202 test_commit_added_subdirs() {
203 local testroot=`test_init commit_added_subdirs`
205 got checkout $testroot/repo $testroot/wt > /dev/null
206 ret=$?
207 if [ $ret -ne 0 ]; then
208 test_done "$testroot" "$ret"
209 return 1
210 fi
212 mkdir -p $testroot/wt/d
213 echo "new file" > $testroot/wt/d/new
214 echo "new file 2" > $testroot/wt/d/new2
215 mkdir -p $testroot/wt/d/f
216 echo "new file 3" > $testroot/wt/d/f/new3
217 mkdir -p $testroot/wt/d/f/g
218 echo "new file 4" > $testroot/wt/d/f/g/new4
220 (cd $testroot/wt && got add $testroot/wt/*/new* \
221 $testroot/wt/*/*/new* $testroot/wt/*/*/*/new* > /dev/null)
223 (cd $testroot/wt && got commit -m 'test commit_added_subdirs' \
224 > $testroot/stdout 2> $testroot/stderr)
226 local head_rev=`git_show_head $testroot/repo`
227 echo "A d/f/g/new4" > $testroot/stdout.expected
228 echo "A d/f/new3" >> $testroot/stdout.expected
229 echo "A d/new" >> $testroot/stdout.expected
230 echo "A d/new2" >> $testroot/stdout.expected
231 echo "Created commit $head_rev" >> $testroot/stdout.expected
233 cmp -s $testroot/stdout.expected $testroot/stdout
234 ret=$?
235 if [ $ret -ne 0 ]; then
236 diff -u $testroot/stdout.expected $testroot/stdout
237 fi
238 test_done "$testroot" "$ret"
241 test_commit_deleted_subdirs() {
242 local testroot=`test_init commit_deleted_subdirs`
244 got checkout $testroot/repo $testroot/wt > /dev/null
245 ret=$?
246 if [ $ret -ne 0 ]; then
247 test_done "$testroot" "$ret"
248 return 1
249 fi
251 (cd $testroot/wt && \
252 got rm -R $testroot/wt/epsilon $testroot/wt/gamma >/dev/null)
254 (cd $testroot/wt && got commit -m 'test commit_deleted_subdirs' \
255 > $testroot/stdout 2> $testroot/stderr)
257 local head_rev=`git_show_head $testroot/repo`
258 echo "D epsilon/zeta" > $testroot/stdout.expected
259 echo "D gamma/delta" >> $testroot/stdout.expected
260 echo "Created commit $head_rev" >> $testroot/stdout.expected
262 cmp -s $testroot/stdout.expected $testroot/stdout
263 ret=$?
264 if [ $ret -ne 0 ]; then
265 diff -u $testroot/stdout.expected $testroot/stdout
266 test_done "$testroot" "$ret"
267 return 1
268 fi
270 got tree -r $testroot/repo > $testroot/stdout
272 echo "alpha" > $testroot/stdout.expected
273 echo "beta" >> $testroot/stdout.expected
275 cmp -s $testroot/stdout.expected $testroot/stdout
276 ret=$?
277 if [ $ret -ne 0 ]; then
278 diff -u $testroot/stdout.expected $testroot/stdout
279 fi
280 test_done "$testroot" "$ret"
283 test_commit_rejects_conflicted_file() {
284 local testroot=`test_init commit_rejects_conflicted_file`
286 local initial_rev=`git_show_head $testroot/repo`
288 got checkout $testroot/repo $testroot/wt > /dev/null
289 ret=$?
290 if [ $ret -ne 0 ]; then
291 test_done "$testroot" "$ret"
292 return 1
293 fi
295 echo "modified alpha" > $testroot/wt/alpha
296 (cd $testroot/wt && got commit -m "modified alpha" >/dev/null)
297 local commit_id1=`git_show_head $testroot/repo`
299 (cd $testroot/wt && got update -c $initial_rev > /dev/null)
301 echo "modified alpha, too" > $testroot/wt/alpha
303 echo "C alpha" > $testroot/stdout.expected
304 echo -n "Updated to refs/heads/master: " >> $testroot/stdout.expected
305 git_show_head $testroot/repo >> $testroot/stdout.expected
306 echo >> $testroot/stdout.expected
307 echo "Files with new merge conflicts: 1" >> $testroot/stdout.expected
309 (cd $testroot/wt && got update > $testroot/stdout)
311 cmp -s $testroot/stdout.expected $testroot/stdout
312 ret=$?
313 if [ $ret -ne 0 ]; then
314 diff -u $testroot/stdout.expected $testroot/stdout
315 test_done "$testroot" "$ret"
316 return 1
317 fi
319 (cd $testroot/wt && got commit -m 'commit it' > $testroot/stdout \
320 2> $testroot/stderr)
321 ret=$?
322 if [ $ret -eq 0 ]; then
323 echo "got commit succeeded unexpectedly"
324 test_done "$testroot" "$ret"
325 return 1
326 fi
328 echo "C alpha" > $testroot/stdout.expected
329 echo "got: cannot commit file in conflicted status" \
330 > $testroot/stderr.expected
332 cmp -s $testroot/stdout.expected $testroot/stdout
333 ret=$?
334 if [ $ret -ne 0 ]; then
335 diff -u $testroot/stdout.expected $testroot/stdout
336 test_done "$testroot" "$ret"
337 return 1
338 fi
339 cmp -s $testroot/stderr.expected $testroot/stderr
340 ret=$?
341 if [ $ret -ne 0 ]; then
342 diff -u $testroot/stderr.expected $testroot/stderr
343 test_done "$testroot" "$ret"
344 return 1
345 fi
347 (cd $testroot/wt && got commit -C -m 'commit it' > $testroot/stdout \
348 2> $testroot/stderr)
349 ret=$?
350 if [ $ret -ne 0 ]; then
351 echo "got commit failed unexpectedly"
352 test_done "$testroot" "$ret"
353 return 1
354 fi
356 # make sure the conflicted commit produces a diff
357 local conflict_commit=`git_show_head $testroot/repo`
358 local blob_minus=`got tree -r $testroot/repo -c $commit_id1 -i | \
359 grep 'alpha$' | cut -d' ' -f1`
360 local blob_plus=`got tree -r $testroot/repo -c $conflict_commit -i | \
361 grep 'alpha$' | cut -d' ' -f1`
363 echo -n > $testroot/stderr.expected
364 cmp -s $testroot/stderr.expected $testroot/stderr
365 ret=$?
366 if [ $ret -ne 0 ]; then
367 diff -u $testroot/stderr.expected $testroot/stderr
368 test_done "$testroot" "$ret"
369 return 1
370 fi
372 (cd $testroot/wt && got diff -c master > $testroot/stdout)
374 echo -n > $testroot/stdout.expected
375 cat > $testroot/stdout.expected <<EOF
376 diff $commit_id1 refs/heads/master
377 commit - $commit_id1
378 commit + $conflict_commit
379 blob - $blob_minus
380 blob + $blob_plus
381 --- alpha
382 +++ alpha
383 @@ -1 +1,7 @@
384 +<<<<<<< merged change: commit $commit_id1
385 modified alpha
386 +||||||| 3-way merge base: commit $initial_rev
387 +alpha
388 +=======
389 +modified alpha, too
390 +>>>>>>>
391 EOF
393 cmp -s $testroot/stdout.expected $testroot/stdout
394 ret=$?
395 if [ $ret -ne 0 ]; then
396 diff -u $testroot/stdout.expected $testroot/stdout
397 test_done "$testroot" "$ret"
398 return 1
399 fi
401 (cd $testroot/wt && got status > $testroot/stdout)
403 echo -n > $testroot/stdout.expected
404 cmp -s $testroot/stdout.expected $testroot/stdout
405 ret=$?
406 if [ $ret -ne 0 ]; then
407 diff -u $testroot/stdout.expected $testroot/stdout
408 fi
409 test_done "$testroot" "$ret"
412 test_commit_single_file_multiple() {
413 local testroot=`test_init commit_single_file_multiple`
415 got checkout $testroot/repo $testroot/wt > /dev/null
416 ret=$?
417 if [ $ret -ne 0 ]; then
418 test_done "$testroot" "$ret"
419 return 1
420 fi
422 for i in 1 2 3 4; do
423 echo "modified alpha" >> $testroot/wt/alpha
425 (cd $testroot/wt && \
426 got commit -m "changed alpha" > $testroot/stdout)
428 local head_rev=`git_show_head $testroot/repo`
429 echo "M alpha" > $testroot/stdout.expected
430 echo "Created commit $head_rev" >> $testroot/stdout.expected
432 cmp -s $testroot/stdout.expected $testroot/stdout
433 ret=$?
434 if [ $ret -ne 0 ]; then
435 diff -u $testroot/stdout.expected $testroot/stdout
436 test_done "$testroot" "$ret"
437 return 1
438 fi
439 done
441 test_done "$testroot" "0"
444 test_commit_added_and_modified_in_same_dir() {
445 local testroot=`test_init commit_added_and_modified_in_same_dir`
447 got checkout $testroot/repo $testroot/wt > /dev/null
448 ret=$?
449 if [ $ret -ne 0 ]; then
450 test_done "$testroot" "$ret"
451 return 1
452 fi
454 echo "modified zeta" > $testroot/wt/epsilon/zeta
455 echo "new file" > $testroot/wt/epsilon/new
456 (cd $testroot/wt && got add epsilon/new >/dev/null)
458 (cd $testroot/wt && got commit \
459 -m 'added and modified in same dir' > $testroot/stdout \
460 2> $testroot/stderr)
462 local head_rev=`git_show_head $testroot/repo`
463 echo "A epsilon/new" > $testroot/stdout.expected
464 echo "M epsilon/zeta" >> $testroot/stdout.expected
465 echo "Created commit $head_rev" >> $testroot/stdout.expected
467 cmp -s $testroot/stdout.expected $testroot/stdout
468 ret=$?
469 if [ $ret -ne 0 ]; then
470 diff -u $testroot/stdout.expected $testroot/stdout
471 fi
472 test_done "$testroot" "$ret"
475 test_commit_path_prefix() {
476 local testroot=`test_init commit_path_prefix`
477 local commit1=`git_show_head $testroot/repo`
479 got checkout -p gamma $testroot/repo $testroot/wt > /dev/null
480 ret=$?
481 if [ $ret -ne 0 ]; then
482 test_done "$testroot" "$ret"
483 return 1
484 fi
486 echo "modified delta" > $testroot/wt/delta
488 (cd $testroot/wt && got commit -m 'changed gamma/delta' > $testroot/stdout)
490 local commit2=`git_show_head $testroot/repo`
491 echo "M delta" > $testroot/stdout.expected
492 echo "Created commit $commit2" >> $testroot/stdout.expected
494 cmp -s $testroot/stdout.expected $testroot/stdout
495 ret=$?
496 if [ $ret -ne 0 ]; then
497 diff -u $testroot/stdout.expected $testroot/stdout
498 test_done "$testroot" "$ret"
499 return 1
500 fi
502 echo "diff $commit1 $commit2" > $testroot/stdout.expected
503 echo "commit - $commit1" >> $testroot/stdout.expected
504 echo "commit + $commit2" >> $testroot/stdout.expected
505 echo -n 'blob - ' >> $testroot/stdout.expected
506 got tree -r $testroot/repo -c $commit1 -i gamma | grep 'delta$' \
507 | cut -d' ' -f 1 >> $testroot/stdout.expected
508 echo -n 'blob + ' >> $testroot/stdout.expected
509 got tree -r $testroot/repo -c $commit2 -i gamma | grep 'delta$' | \
510 cut -d' ' -f 1 >> $testroot/stdout.expected
511 echo '--- gamma/delta' >> $testroot/stdout.expected
512 echo '+++ gamma/delta' >> $testroot/stdout.expected
513 echo '@@ -1 +1 @@' >> $testroot/stdout.expected
514 echo '-delta' >> $testroot/stdout.expected
515 echo '+modified delta' >> $testroot/stdout.expected
517 got diff -r $testroot/repo $commit1 $commit2 > $testroot/stdout
518 cmp -s $testroot/stdout.expected $testroot/stdout
519 ret=$?
520 if [ $ret -ne 0 ]; then
521 diff -u $testroot/stdout.expected $testroot/stdout
522 test_done "$testroot" "$ret"
523 return 1
524 fi
526 (cd $testroot/wt && got rm delta > /dev/null)
527 echo new > $testroot/wt/new
528 (cd $testroot/wt && got add new > /dev/null)
530 (cd $testroot/wt && got commit -m 'remove gamma/delta; add gamma/new' \
531 > $testroot/stdout)
533 local commit3=`git_show_head $testroot/repo`
534 echo "A new" > $testroot/stdout.expected
535 echo "D delta" >> $testroot/stdout.expected
536 echo "Created commit $commit3" >> $testroot/stdout.expected
538 cmp -s $testroot/stdout.expected $testroot/stdout
539 ret=$?
540 if [ $ret -ne 0 ]; then
541 diff -u $testroot/stdout.expected $testroot/stdout
542 test_done "$testroot" "$ret"
543 return 1
544 fi
546 echo "diff $commit2 $commit3" > $testroot/stdout.expected
547 echo "commit - $commit2" >> $testroot/stdout.expected
548 echo "commit + $commit3" >> $testroot/stdout.expected
549 echo -n 'blob - ' >> $testroot/stdout.expected
550 got tree -r $testroot/repo -c $commit2 -i gamma | grep 'delta$' \
551 | cut -d' ' -f 1 | sed -e 's/$/ (mode 644)/' \
552 >> $testroot/stdout.expected
553 echo 'blob + /dev/null' >> $testroot/stdout.expected
554 echo '--- gamma/delta' >> $testroot/stdout.expected
555 echo '+++ /dev/null' >> $testroot/stdout.expected
556 echo '@@ -1 +0,0 @@' >> $testroot/stdout.expected
557 echo '-modified delta' >> $testroot/stdout.expected
558 echo 'blob - /dev/null' >> $testroot/stdout.expected
559 echo -n 'blob + ' >> $testroot/stdout.expected
560 got tree -r $testroot/repo -c $commit3 -i gamma | grep 'new$' | \
561 cut -d' ' -f 1 | sed -e 's/$/ (mode 644)/' \
562 >> $testroot/stdout.expected
563 echo '--- /dev/null' >> $testroot/stdout.expected
564 echo '+++ gamma/new' >> $testroot/stdout.expected
565 echo '@@ -0,0 +1 @@' >> $testroot/stdout.expected
566 echo '+new' >> $testroot/stdout.expected
568 got diff -r $testroot/repo $commit2 $commit3 > $testroot/stdout
569 cmp -s $testroot/stdout.expected $testroot/stdout
570 ret=$?
571 if [ $ret -ne 0 ]; then
572 diff -u $testroot/stdout.expected $testroot/stdout
573 fi
574 test_done "$testroot" "$ret"
575 return "$ret"
578 test_commit_dir_path() {
579 local testroot=`test_init commit_dir_path`
581 got checkout $testroot/repo $testroot/wt > /dev/null
582 ret=$?
583 if [ $ret -ne 0 ]; then
584 test_done "$testroot" "$ret"
585 return 1
586 fi
588 echo "modified alpha" > $testroot/wt/alpha
589 echo "modified zeta" > $testroot/wt/epsilon/zeta
591 (cd $testroot/wt && got commit -m 'changed zeta' epsilon \
592 > $testroot/stdout)
594 local head_rev=`git_show_head $testroot/repo`
595 echo "M epsilon/zeta" >> $testroot/stdout.expected
596 echo "Created commit $head_rev" >> $testroot/stdout.expected
598 cmp -s $testroot/stdout.expected $testroot/stdout
599 ret=$?
600 if [ $ret -ne 0 ]; then
601 diff -u $testroot/stdout.expected $testroot/stdout
602 test_done "$testroot" "$ret"
603 return 1
604 fi
606 echo "M alpha" > $testroot/stdout.expected
607 (cd $testroot/wt && got status > $testroot/stdout)
608 cmp -s $testroot/stdout.expected $testroot/stdout
609 ret=$?
610 if [ $ret -ne 0 ]; then
611 diff -u $testroot/stdout.expected $testroot/stdout
612 fi
613 test_done "$testroot" "$ret"
616 test_commit_selected_paths() {
617 local testroot=`test_init commit_selected_paths`
619 got checkout $testroot/repo $testroot/wt > /dev/null
620 ret=$?
621 if [ $ret -ne 0 ]; then
622 test_done "$testroot" "$ret"
623 return 1
624 fi
626 echo "modified alpha" > $testroot/wt/alpha
627 echo "modified delta" > $testroot/wt/gamma/delta
628 echo "modified zeta" > $testroot/wt/epsilon/zeta
629 (cd $testroot/wt && got rm beta >/dev/null)
630 echo "new file" > $testroot/wt/new
631 (cd $testroot/wt && got add new >/dev/null)
633 (cd $testroot/wt && got commit -m 'many paths' nonexistent alpha \
634 > $testroot/stdout 2> $testroot/stderr)
635 ret=$?
636 if [ $ret -eq 0 ]; then
637 echo "commit succeeded unexpectedly" >&2
638 test_done "$testroot" "1"
639 return 1
640 fi
641 echo "got: nonexistent: bad path" > $testroot/stderr.expected
643 cmp -s $testroot/stderr.expected $testroot/stderr
644 ret=$?
645 if [ $ret -ne 0 ]; then
646 diff -u $testroot/stderr.expected $testroot/stderr
647 test_done "$testroot" "$ret"
648 return 1
649 fi
651 (cd $testroot/wt && got commit -m 'many paths' \
652 beta new gamma > $testroot/stdout)
654 local head_rev=`git_show_head $testroot/repo`
655 echo "A new" > $testroot/stdout.expected
656 echo "D beta" >> $testroot/stdout.expected
657 echo "M gamma/delta" >> $testroot/stdout.expected
658 echo "Created commit $head_rev" >> $testroot/stdout.expected
660 cmp -s $testroot/stdout.expected $testroot/stdout
661 ret=$?
662 if [ $ret -ne 0 ]; then
663 diff -u $testroot/stdout.expected $testroot/stdout
664 fi
665 test_done "$testroot" "$ret"
668 test_commit_outside_refs_heads() {
669 local testroot=`test_init commit_outside_refs_heads`
671 got ref -r $testroot/repo -c master refs/remotes/origin/master
673 got checkout -b refs/remotes/origin/master \
674 $testroot/repo $testroot/wt > /dev/null
675 ret=$?
676 if [ $ret -ne 0 ]; then
677 test_done "$testroot" "$ret"
678 return 1
679 fi
681 echo "modified alpha" > $testroot/wt/alpha
683 (cd $testroot/wt && got commit -m 'change alpha' \
684 > $testroot/stdout 2> $testroot/stderr)
685 ret=$?
686 if [ $ret -eq 0 ]; then
687 echo "commit succeeded unexpectedly" >&2
688 test_done "$testroot" "1"
689 return 1
690 fi
692 echo -n > $testroot/stdout.expected
693 cmp -s $testroot/stdout.expected $testroot/stdout
694 ret=$?
695 if [ $ret -ne 0 ]; then
696 diff -u $testroot/stdout.expected $testroot/stdout
697 test_done "$testroot" "$ret"
698 return 1
699 fi
701 echo -n "got: will not commit to a branch outside the " \
702 > $testroot/stderr.expected
703 echo '"refs/heads/" reference namespace' \
704 >> $testroot/stderr.expected
705 cmp -s $testroot/stderr.expected $testroot/stderr
706 ret=$?
707 if [ $ret -ne 0 ]; then
708 diff -u $testroot/stderr.expected $testroot/stderr
709 fi
710 test_done "$testroot" "$ret"
713 test_commit_no_email() {
714 local testroot=`test_init commit_no_email`
715 local errmsg=""
717 errmsg="commit author's email address is required for"
718 errmsg="$errmsg compatibility with Git"
720 got checkout $testroot/repo $testroot/wt > /dev/null
721 ret=$?
722 if [ $ret -ne 0 ]; then
723 test_done "$testroot" "$ret"
724 return 1
725 fi
727 echo "modified alpha" > $testroot/wt/alpha
728 (cd $testroot/wt && env GOT_AUTHOR=":flan_hacker:" \
729 got commit -m 'test no email' > $testroot/stdout \
730 2> $testroot/stderr)
732 printf "got: :flan_hacker:: %s\n" "$errmsg" > $testroot/stderr.expected
733 cmp -s $testroot/stderr.expected $testroot/stderr
734 ret=$?
735 if [ $ret -ne 0 ]; then
736 diff -u $testroot/stderr.expected $testroot/stderr
737 test_done "$testroot" "$ret"
738 return 1
739 fi
741 echo -n > $testroot/stdout.expected
742 cmp -s $testroot/stdout.expected $testroot/stdout
743 ret=$?
744 if [ $ret -ne 0 ]; then
745 diff -u $testroot/stdout.expected $testroot/stdout
746 test_done "$testroot" $ret
747 return 1
748 fi
750 # try again with a newline inside the email
751 (cd $testroot/wt \
752 && FS=' ' env GOT_AUTHOR="$(printf "Flan <hack\ner>")" \
753 got commit -m 'test invalid email' > $testroot/stdout \
754 2> $testroot/stderr)
756 printf "got: Flan <hack\ner>: %s\n" "$errmsg" \
757 > $testroot/stderr.expected
758 cmp -s $testroot/stderr.expected $testroot/stderr
759 ret=$?
760 if [ $ret -ne 0 ]; then
761 diff -u $testroot/stderr.expected $testroot/stderr
762 test_done "$testroot" $ret
763 return 1
764 fi
766 echo -n > $testroot/stdout.expected
767 cmp -s $testroot/stdout.expected $testroot/stdout
768 ret=$?
769 if [ $ret -ne 0 ]; then
770 diff -u $testroot/stdout.expected $testroot/stdout
771 test_done "$testroot" $ret
772 return 1
773 fi
775 # try again with a < inside the email
776 (cd $testroot/wt && env GOT_AUTHOR="$(printf "Flan <ha<ker>")" \
777 got commit -m 'test invalid email' > $testroot/stdout \
778 2> $testroot/stderr)
780 printf "got: Flan <ha<ker>: %s\n" "$errmsg" > $testroot/stderr.expected
781 cmp -s $testroot/stderr.expected $testroot/stderr
782 ret=$?
783 if [ $ret -ne 0 ]; then
784 diff -u $testroot/stderr.expected $testroot/stderr
785 test_done "$testroot" $ret
786 return 1
787 fi
789 echo -n > $testroot/stdout.expected
790 cmp -s $testroot/stdout.expected $testroot/stdout
791 ret=$?
792 if [ $ret -ne 0 ]; then
793 diff -u $testroot/stdout.expected $testroot/stdout
794 fi
795 test_done "$testroot" $ret
798 test_commit_tree_entry_sorting() {
799 local testroot=`test_init commit_tree_entry_sorting`
801 got checkout $testroot/repo $testroot/wt > /dev/null
802 ret=$?
803 if [ $ret -ne 0 ]; then
804 test_done "$testroot" "$ret"
805 return 1
806 fi
808 # Git's index gets corrupted when tree entries are written in the
809 # order defined by got_path_cmp() rather than Git's own ordering.
810 # Create a new tree where a directory "got" and a file "got-version"
811 # would sort in the wrong order according to Git's opinion.
812 mkdir $testroot/wt/got
813 touch $testroot/wt/got/foo
814 echo foo > $testroot/wt/got-version
815 echo zzz > $testroot/wt/zzz
816 (cd $testroot/wt && got add got-version got/foo zzz > /dev/null)
818 (cd $testroot/wt && got commit -m 'test' > /dev/null)
820 # Let git-fsck verify the newly written tree to make sure Git is happy
821 (cd $testroot/repo && git fsck --strict \
822 > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
823 ret=$?
824 test_done "$testroot" "$ret"
827 test_commit_cmdline_author() {
828 local testroot=`test_init commit_cmdline_author`
830 got checkout $testroot/repo $testroot/wt > /dev/null
831 ret=$?
832 if [ $ret -ne 0 ]; then
833 test_done "$testroot" $ret
834 return 1
835 fi
837 echo "modified alpha" > $testroot/wt/alpha
839 local author="Foo <foo@example.com>"
840 (cd $testroot/wt && got commit -A "$author" -m 'edit alpha') \
841 > /dev/null
842 ret=$?
843 if [ $ret -ne 0 ]; then
844 test_done "$testroot" $ret
845 return 1
846 fi
848 (cd $testroot/repo && got log -l1 | egrep '^(from|via):') \
849 > $testroot/stdout
850 ret=$?
851 if [ $ret -ne 0 ]; then
852 test_done "$testroot" $ret
853 return 1
854 fi
856 echo "from: $author" > $testroot/stdout.expected
857 echo "via: $GOT_AUTHOR" >> $testroot/stdout.expected
858 cmp -s $testroot/stdout.expected $testroot/stdout
859 ret=$?
860 if [ $ret -ne 0 ]; then
861 diff -u $testroot/stdout.expected $testroot/stdout
862 fi
863 test_done "$testroot" $ret
866 test_commit_gotconfig_author() {
867 local testroot=`test_init commit_gotconfig_author`
869 got checkout $testroot/repo $testroot/wt > /dev/null
870 ret=$?
871 if [ $ret -ne 0 ]; then
872 test_done "$testroot" "$ret"
873 return 1
874 fi
875 echo 'author "Flan Luck <flan_luck@openbsd.org>"' \
876 > $testroot/repo/.git/got.conf
878 echo "modified alpha" > $testroot/wt/alpha
879 (cd $testroot/wt && got commit -m 'test gotconfig author' > /dev/null)
880 ret=$?
881 if [ $ret -ne 0 ]; then
882 test_done "$testroot" "$ret"
883 return 1
884 fi
886 (cd $testroot/repo && got log -l1 | grep ^from: > $testroot/stdout)
887 ret=$?
888 if [ $ret -ne 0 ]; then
889 test_done "$testroot" "$ret"
890 return 1
891 fi
893 echo "from: Flan Luck <flan_luck@openbsd.org>" \
894 > $testroot/stdout.expected
895 cmp -s $testroot/stdout.expected $testroot/stdout
896 ret=$?
897 if [ $ret -ne 0 ]; then
898 diff -u $testroot/stdout.expected $testroot/stdout
899 fi
900 test_done "$testroot" "$ret"
903 test_commit_gotconfig_worktree_author() {
904 local testroot=`test_init commit_gotconfig_worktree_author`
906 got checkout $testroot/repo $testroot/wt > /dev/null
907 ret=$?
908 if [ $ret -ne 0 ]; then
909 test_done "$testroot" "$ret"
910 return 1
911 fi
912 echo 'author "Flan Luck <flan_luck@openbsd.org>"' \
913 > $testroot/repo/.git/got.conf
914 echo 'author "Flan Squee <flan_squee@openbsd.org>"' \
915 > $testroot/wt/.got/got.conf
917 echo "modified alpha" > $testroot/wt/alpha
918 (cd $testroot/wt && got commit -m 'test gotconfig author' > /dev/null)
919 ret=$?
920 if [ $ret -ne 0 ]; then
921 test_done "$testroot" "$ret"
922 return 1
923 fi
925 (cd $testroot/repo && got log -l1 | grep ^from: > $testroot/stdout)
926 ret=$?
927 if [ $ret -ne 0 ]; then
928 test_done "$testroot" "$ret"
929 return 1
930 fi
932 echo "from: Flan Squee <flan_squee@openbsd.org>" \
933 > $testroot/stdout.expected
934 cmp -s $testroot/stdout.expected $testroot/stdout
935 ret=$?
936 if [ $ret -ne 0 ]; then
937 diff -u $testroot/stdout.expected $testroot/stdout
938 fi
939 test_done "$testroot" "$ret"
942 test_commit_gitconfig_author() {
943 local testroot=`test_init commit_gitconfig_author`
945 got checkout $testroot/repo $testroot/wt > /dev/null
946 ret=$?
947 if [ $ret -ne 0 ]; then
948 test_done "$testroot" "$ret"
949 return 1
950 fi
952 (cd $testroot/repo && git config user.name 'Flan Luck')
953 (cd $testroot/repo && git config user.email 'flan_luck@openbsd.org')
955 echo "modified alpha" > $testroot/wt/alpha
957 # unset in a subshell to avoid affecting our environment
958 (unset GOT_IGNORE_GITCONFIG && cd $testroot/wt && \
959 got commit -m 'test gitconfig author' > /dev/null)
960 ret=$?
961 if [ $ret -ne 0 ]; then
962 test_done "$testroot" "$ret"
963 return 1
964 fi
966 (cd $testroot/repo && got log -l1 | grep ^from: > $testroot/stdout)
967 ret=$?
968 if [ $ret -ne 0 ]; then
969 test_done "$testroot" "$ret"
970 return 1
971 fi
973 echo "from: Flan Luck <flan_luck@openbsd.org>" \
974 > $testroot/stdout.expected
975 cmp -s $testroot/stdout.expected $testroot/stdout
976 ret=$?
977 if [ $ret -ne 0 ]; then
978 diff -u $testroot/stdout.expected $testroot/stdout
979 test_done "$testroot" "$ret"
980 return 1
981 fi
983 # retry with spaces in the git config
984 ed -s "$testroot/repo/.git/config" <<EOF
985 ,s/ / /g
986 wq
987 EOF
988 echo "modified again" > $testroot/wt/alpha
990 # unset in a subshell to avoid affecting our environment
991 (unset GOT_IGNORE_GITCONFIG && cd "$testroot/wt" && \
992 got commit -m 'test gitconfig author again' >/dev/null)
993 ret=$?
994 if [ $ret -ne 0 ]; then
995 test_done "$testroot" "$ret"
996 return 1
997 fi
999 (cd "$testroot/repo" && got log -l1 | grep ^from: > $testroot/stdout)
1000 ret=$?
1001 if [ $ret -ne 0 ]; then
1002 test_done "$testroot" "$ret"
1003 return 1
1006 echo "from: Flan Luck <flan_luck@openbsd.org>" \
1007 > $testroot/stdout.expected
1008 cmp -s $testroot/stdout.expected $testroot/stdout
1009 ret=$?
1010 if [ $ret -ne 0 ]; then
1011 diff -u $testroot/stdout.expected $testroot/stdout
1013 test_done "$testroot" "$ret"
1016 test_commit_xbit_change() {
1017 local testroot=`test_init commit_xbit_change`
1019 got checkout $testroot/repo $testroot/wt > /dev/null
1020 ret=$?
1021 if [ $ret -ne 0 ]; then
1022 test_done "$testroot" "$ret"
1023 return 1
1026 chmod +x $testroot/wt/alpha
1028 echo 'm alpha' > $testroot/stdout.expected
1029 (cd $testroot/wt && got status > $testroot/stdout)
1031 cmp -s $testroot/stdout.expected $testroot/stdout
1032 ret=$?
1033 if [ $ret -ne 0 ]; then
1034 diff -u $testroot/stdout.expected $testroot/stdout
1035 test_done "$testroot" "$ret"
1036 return 1
1039 (cd $testroot/wt && got commit -mx > $testroot/stdout)
1040 ret=$?
1041 if [ $ret -ne 0 ]; then
1042 echo "got commit failed unexpectedly"
1043 test_done "$testroot" "$ret"
1044 return 1
1047 local commit_id=`git_show_head $testroot/repo`
1048 echo 'm alpha' > $testroot/stdout.expected
1049 echo "Created commit $commit_id" >> $testroot/stdout.expected
1050 cmp -s $testroot/stdout.expected $testroot/stdout
1051 ret=$?
1052 if [ $ret -ne 0 ]; then
1053 diff -u $testroot/stdout.expected $testroot/stdout
1054 test_done "$testroot" "$ret"
1055 return 1
1058 (cd $testroot/wt && got status > $testroot/stdout)
1060 echo -n > $testroot/stdout.expected
1061 cmp -s $testroot/stdout.expected $testroot/stdout
1062 ret=$?
1063 if [ $ret -ne 0 ]; then
1064 diff -u $testroot/stdout.expected $testroot/stdout
1065 test_done "$testroot" "$ret"
1066 return 1
1069 chmod -x $testroot/wt/alpha
1071 echo 'm alpha' > $testroot/stdout.expected
1072 (cd $testroot/wt && got status > $testroot/stdout)
1074 cmp -s $testroot/stdout.expected $testroot/stdout
1075 ret=$?
1076 if [ $ret -ne 0 ]; then
1077 diff -u $testroot/stdout.expected $testroot/stdout
1078 test_done "$testroot" "$ret"
1079 return 1
1082 (cd $testroot/wt && got commit -mx > $testroot/stdout)
1083 ret=$?
1084 if [ $ret -ne 0 ]; then
1085 echo "got commit failed unexpectedly"
1086 test_done "$testroot" "$ret"
1087 return 1
1090 local commit_id=`git_show_head $testroot/repo`
1091 echo 'm alpha' > $testroot/stdout.expected
1092 echo "Created commit $commit_id" >> $testroot/stdout.expected
1093 cmp -s $testroot/stdout.expected $testroot/stdout
1094 ret=$?
1095 if [ $ret -ne 0 ]; then
1096 diff -u $testroot/stdout.expected $testroot/stdout
1097 test_done "$testroot" "$ret"
1098 return 1
1101 chmod +x $testroot/wt/alpha
1103 echo 'm alpha' > $testroot/stdout.expected
1104 (cd $testroot/wt && got status > $testroot/stdout)
1106 cmp -s $testroot/stdout.expected $testroot/stdout
1107 ret=$?
1108 if [ $ret -ne 0 ]; then
1109 diff -u $testroot/stdout.expected $testroot/stdout
1111 test_done "$testroot" "$ret"
1114 commit_check_mode() {
1115 local mode="$1"
1116 local expected_mode="$2"
1118 chmod 644 $testroot/wt/alpha
1119 echo a >> $testroot/wt/alpha
1120 chmod $mode $testroot/wt/alpha
1122 (cd $testroot/wt && got commit -mm > $testroot/stdout)
1123 ret=$?
1124 if [ $ret -ne 0 ]; then
1125 echo "got commit failed unexpectedly"
1126 test_done "$testroot" "$ret"
1127 return 1
1130 local commit_id=`git_show_head $testroot/repo`
1131 echo 'M alpha' > $testroot/stdout.expected
1132 echo "Created commit $commit_id" >> $testroot/stdout.expected
1133 cmp -s $testroot/stdout.expected $testroot/stdout
1134 ret=$?
1135 if [ $ret -ne 0 ]; then
1136 diff -u $testroot/stdout.expected $testroot/stdout
1137 test_done "$testroot" "$ret"
1138 return 1
1141 local tree_id=$(got cat -r $testroot/repo $commit_id | \
1142 grep ^tree | cut -d' ' -f2)
1143 local alpha_id=$(got cat -r $testroot/repo $tree_id | \
1144 grep 'alpha$' | cut -d' ' -f1)
1145 echo "$alpha_id $expected_mode alpha" > $testroot/stdout.expected
1146 got cat -r $testroot/repo $tree_id | grep 'alpha$' > $testroot/stdout
1147 cmp -s $testroot/stdout.expected $testroot/stdout
1148 ret=$?
1149 if [ $ret -ne 0 ]; then
1150 diff -u $testroot/stdout.expected $testroot/stdout
1152 return $ret
1155 test_commit_normalizes_filemodes() {
1156 local testroot=`test_init commit_normalizes_filemodes`
1158 got checkout $testroot/repo $testroot/wt > /dev/null
1159 ret=$?
1160 if [ $ret -ne 0 ]; then
1161 test_done "$testroot" "$ret"
1162 return 1
1165 modes="600 400 460 640 440 660 444 666"
1166 for m in $modes; do
1167 commit_check_mode "$m" "0100644"
1168 ret=$?
1169 if [ $ret -ne 0 ]; then
1170 break
1172 done
1173 if [ $ret -ne 0 ]; then
1174 test_done "$testroot" "$ret"
1175 return 1
1177 modes="700 500 570 750 550 770 555 777"
1178 for m in $modes; do
1179 commit_check_mode "$m" "0100755"
1180 ret=$?
1181 if [ $ret -ne 0 ]; then
1182 break
1184 done
1185 if [ $ret -ne 0 ]; then
1186 test_done "$testroot" "$ret"
1187 return 1
1189 test_done "$testroot" "$ret"
1192 test_commit_with_unrelated_submodule() {
1193 local testroot=`test_init commit_with_unrelated_submodule`
1195 make_single_file_repo $testroot/repo2 foo
1197 (cd $testroot/repo && git -c protocol.file.allow=always \
1198 submodule -q add ../repo2)
1199 (cd $testroot/repo && git commit -q -m 'adding submodule')
1201 got checkout $testroot/repo $testroot/wt > /dev/null
1202 ret=$?
1203 if [ $ret -ne 0 ]; then
1204 echo "checkout failed unexpectedly" >&2
1205 test_done "$testroot" "$ret"
1206 return 1
1209 echo "modified alpha" > $testroot/wt/alpha
1211 echo "" > $testroot/stdout.expected
1213 (cd $testroot/wt && got commit -m 'modify alpha' > $testroot/stdout)
1214 ret=$?
1215 if [ $ret -ne 0 ]; then
1216 echo "commit failed unexpectedly" >&2
1217 test_done "$testroot" "$ret"
1218 return 1
1221 local head_rev=`git_show_head $testroot/repo`
1222 echo "M alpha" > $testroot/stdout.expected
1223 echo "Created commit $head_rev" >> $testroot/stdout.expected
1225 cmp -s $testroot/stdout.expected $testroot/stdout
1226 ret=$?
1227 if [ $ret -ne 0 ]; then
1228 diff -u $testroot/stdout.expected $testroot/stdout
1230 test_done "$testroot" "$ret"
1233 check_symlinks() {
1234 local wtpath="$1"
1235 if ! [ -h $wtpath/alpha.link ]; then
1236 echo "alpha.link is not a symlink"
1237 return 1
1240 readlink $wtpath/alpha.link > $testroot/stdout
1241 echo "alpha" > $testroot/stdout.expected
1242 cmp -s $testroot/stdout.expected $testroot/stdout
1243 ret=$?
1244 if [ $ret -ne 0 ]; then
1245 diff -u $testroot/stdout.expected $testroot/stdout
1246 return 1
1249 if ! [ -h $wtpath/epsilon.link ]; then
1250 echo "epsilon.link is not a symlink"
1251 return 1
1254 readlink $wtpath/epsilon.link > $testroot/stdout
1255 echo "epsilon" > $testroot/stdout.expected
1256 cmp -s $testroot/stdout.expected $testroot/stdout
1257 ret=$?
1258 if [ $ret -ne 0 ]; then
1259 diff -u $testroot/stdout.expected $testroot/stdout
1260 return 1
1263 if [ -h $wtpath/passwd.link ]; then
1264 echo -n "passwd.link is a symlink and points outside of work tree: " >&2
1265 readlink $wtpath/passwd.link >&2
1266 return 1
1269 echo -n "/etc/passwd" > $testroot/content.expected
1270 cp $wtpath/passwd.link $testroot/content
1271 ret=$?
1272 if [ $ret -ne 0 ]; then
1273 echo "cp command failed unexpectedly" >&2
1274 return 1
1277 cmp -s $testroot/content.expected $testroot/content
1278 ret=$?
1279 if [ $ret -ne 0 ]; then
1280 diff -u $testroot/content.expected $testroot/content
1281 return 1
1284 readlink $wtpath/epsilon/beta.link > $testroot/stdout
1285 echo "../beta" > $testroot/stdout.expected
1286 cmp -s $testroot/stdout.expected $testroot/stdout
1287 ret=$?
1288 if [ $ret -ne 0 ]; then
1289 diff -u $testroot/stdout.expected $testroot/stdout
1290 return 1
1293 readlink $wtpath/nonexistent.link > $testroot/stdout
1294 echo "nonexistent" > $testroot/stdout.expected
1295 cmp -s $testroot/stdout.expected $testroot/stdout
1296 ret=$?
1297 if [ $ret -ne 0 ]; then
1298 diff -u $testroot/stdout.expected $testroot/stdout
1299 return 1
1302 return 0
1305 test_commit_symlink() {
1306 local testroot=`test_init commit_symlink`
1308 got checkout $testroot/repo $testroot/wt > /dev/null
1309 ret=$?
1310 if [ $ret -ne 0 ]; then
1311 test_done "$testroot" "$ret"
1312 return 1
1315 (cd $testroot/wt && ln -s alpha alpha.link)
1316 (cd $testroot/wt && ln -s epsilon epsilon.link)
1317 (cd $testroot/wt && ln -s /etc/passwd passwd.link)
1318 (cd $testroot/wt && ln -s ../beta epsilon/beta.link)
1319 (cd $testroot/wt && ln -s nonexistent nonexistent.link)
1320 (cd $testroot/wt && got add alpha.link epsilon.link passwd.link \
1321 epsilon/beta.link nonexistent.link > /dev/null)
1323 (cd $testroot/wt && got commit -m 'test commit_symlink' \
1324 > $testroot/stdout 2> $testroot/stderr)
1325 ret=$?
1326 if [ $ret -eq 0 ]; then
1327 echo "got commit succeeded unexpectedly" >&2
1328 test_done "$testroot" "$ret"
1329 return 1
1331 echo -n "got: $testroot/wt/passwd.link: " > $testroot/stderr.expected
1332 echo "symbolic link points outside of paths under version control" \
1333 >> $testroot/stderr.expected
1334 cmp -s $testroot/stderr.expected $testroot/stderr
1335 ret=$?
1336 if [ $ret -ne 0 ]; then
1337 diff -u $testroot/stderr.expected $testroot/stderr
1338 test_done "$testroot" "$ret"
1339 return 1
1342 (cd $testroot/wt && got commit -S -m 'test commit_symlink' \
1343 > $testroot/stdout)
1345 local head_rev=`git_show_head $testroot/repo`
1346 echo "A alpha.link" > $testroot/stdout.expected
1347 echo "A epsilon.link" >> $testroot/stdout.expected
1348 echo "A nonexistent.link" >> $testroot/stdout.expected
1349 echo "A passwd.link" >> $testroot/stdout.expected
1350 echo "A epsilon/beta.link" >> $testroot/stdout.expected
1351 echo "Created commit $head_rev" >> $testroot/stdout.expected
1353 cmp -s $testroot/stdout.expected $testroot/stdout
1354 ret=$?
1355 if [ $ret -ne 0 ]; then
1356 diff -u $testroot/stdout.expected $testroot/stdout
1357 test_done "$testroot" "$ret"
1358 return 1
1361 # verify created in-repository tree
1362 got checkout $testroot/repo $testroot/wt2 > /dev/null
1363 ret=$?
1364 if [ $ret -ne 0 ]; then
1365 test_done "$testroot" "$ret"
1366 return 1
1368 check_symlinks $testroot/wt2
1369 ret=$?
1370 if [ $ret -ne 0 ]; then
1371 test_done "$testroot" "$ret"
1372 return 1
1375 if ! [ -h $testroot/wt/passwd.link ]; then
1376 echo 'passwd.link is not a symlink' >&2
1377 test_done "$testroot" 1
1378 return 1
1381 # 'got update' should reinstall passwd.link as a regular file
1382 (cd $testroot/wt && got update > /dev/null)
1383 check_symlinks $testroot/wt
1384 ret=$?
1385 if [ $ret -ne 0 ]; then
1386 test_done "$testroot" "$ret"
1387 return 1
1390 (cd $testroot/wt && ln -sf beta alpha.link)
1391 (cd $testroot/wt && ln -sfh gamma epsilon.link)
1392 rm $testroot/wt/epsilon/beta.link
1393 echo "this is a regular file" > $testroot/wt/epsilon/beta.link
1394 (cd $testroot/wt && ln -sf .got/bar dotgotbar.link)
1395 (cd $testroot/wt && got add dotgotbar.link > /dev/null)
1396 (cd $testroot/wt && got rm nonexistent.link > /dev/null)
1397 (cd $testroot/wt && ln -sf gamma/delta zeta.link)
1398 (cd $testroot/wt && ln -sf alpha new.link)
1399 (cd $testroot/wt && got add new.link > /dev/null)
1401 (cd $testroot/wt && got commit -m 'test commit_symlink' \
1402 > $testroot/stdout 2> $testroot/stderr)
1403 ret=$?
1404 if [ $ret -eq 0 ]; then
1405 echo "got commit succeeded unexpectedly" >&2
1406 test_done "$testroot" "$ret"
1407 return 1
1409 echo -n "got: $testroot/wt/dotgotbar.link: " > $testroot/stderr.expected
1410 echo "symbolic link points outside of paths under version control" \
1411 >> $testroot/stderr.expected
1412 cmp -s $testroot/stderr.expected $testroot/stderr
1413 ret=$?
1414 if [ $ret -ne 0 ]; then
1415 diff -u $testroot/stderr.expected $testroot/stderr
1416 test_done "$testroot" "$ret"
1417 return 1
1420 (cd $testroot/wt && got commit -S -m 'test commit_symlink' \
1421 > $testroot/stdout)
1423 local head_rev=`git_show_head $testroot/repo`
1424 echo "A dotgotbar.link" > $testroot/stdout.expected
1425 echo "A new.link" >> $testroot/stdout.expected
1426 echo "M alpha.link" >> $testroot/stdout.expected
1427 echo "M epsilon/beta.link" >> $testroot/stdout.expected
1428 echo "M epsilon.link" >> $testroot/stdout.expected
1429 echo "D nonexistent.link" >> $testroot/stdout.expected
1430 echo "Created commit $head_rev" >> $testroot/stdout.expected
1432 cmp -s $testroot/stdout.expected $testroot/stdout
1433 ret=$?
1434 if [ $ret -ne 0 ]; then
1435 diff -u $testroot/stdout.expected $testroot/stdout
1436 test_done "$testroot" "$ret"
1437 return 1
1440 got tree -r $testroot/repo -c $head_rev -R > $testroot/stdout
1441 cat > $testroot/stdout.expected <<EOF
1442 alpha
1443 alpha.link@ -> beta
1444 beta
1445 dotgotbar.link@ -> .got/bar
1446 epsilon/
1447 epsilon/beta.link
1448 epsilon/zeta
1449 epsilon.link@ -> gamma
1450 gamma/
1451 gamma/delta
1452 new.link@ -> alpha
1453 passwd.link@ -> /etc/passwd
1454 EOF
1455 cmp -s $testroot/stdout.expected $testroot/stdout
1456 ret=$?
1457 if [ $ret -ne 0 ]; then
1458 diff -u $testroot/stdout.expected $testroot/stdout
1460 test_done "$testroot" "$ret"
1463 test_commit_fix_bad_symlink() {
1464 local testroot=`test_init commit_fix_bad_symlink`
1466 got checkout $testroot/repo $testroot/wt > /dev/null
1467 ret=$?
1468 if [ $ret -ne 0 ]; then
1469 echo "got checkout failed unexpectedly" >&2
1470 test_done "$testroot" "$ret"
1471 return 1
1474 (cd $testroot/wt && ln -s /etc/passwd passwd.link)
1475 (cd $testroot/wt && got add passwd.link > /dev/null)
1477 (cd $testroot/wt && got commit -S -m 'commit bad symlink' \
1478 > $testroot/stdout)
1480 if ! [ -h $testroot/wt/passwd.link ]; then
1481 echo 'passwd.link is not a symlink' >&2
1482 test_done "$testroot" 1
1483 return 1
1485 (cd $testroot/wt && got update >/dev/null)
1486 if [ -h $testroot/wt/passwd.link ]; then
1487 echo "passwd.link is a symlink but should be a regular file" >&2
1488 test_done "$testroot" "1"
1489 return 1
1492 # create another work tree which will contain the "bad" symlink
1493 got checkout $testroot/repo $testroot/wt2 > /dev/null
1494 ret=$?
1495 if [ $ret -ne 0 ]; then
1496 echo "got checkout failed unexpectedly" >&2
1497 test_done "$testroot" "$ret"
1498 return 1
1501 # change "bad" symlink back into a "good" symlink
1502 (cd $testroot/wt && ln -sfh alpha passwd.link)
1504 (cd $testroot/wt && got commit -m 'fix bad symlink' \
1505 > $testroot/stdout)
1507 local head_rev=`git_show_head $testroot/repo`
1508 echo "M passwd.link" > $testroot/stdout.expected
1509 echo "Created commit $head_rev" >> $testroot/stdout.expected
1511 cmp -s $testroot/stdout.expected $testroot/stdout
1512 ret=$?
1513 if [ $ret -ne 0 ]; then
1514 diff -u $testroot/stdout.expected $testroot/stdout
1515 test_done "$testroot" "$ret"
1516 return 1
1519 if ! [ -h $testroot/wt/passwd.link ]; then
1520 echo 'passwd.link is not a symlink' >&2
1521 test_done "$testroot" 1
1522 return 1
1525 readlink $testroot/wt/passwd.link > $testroot/stdout
1526 echo "alpha" > $testroot/stdout.expected
1527 cmp -s $testroot/stdout.expected $testroot/stdout
1528 ret=$?
1529 if [ $ret -ne 0 ]; then
1530 diff -u $testroot/stdout.expected $testroot/stdout
1531 return 1
1534 # Update the other work tree; the bad symlink should be fixed
1535 (cd $testroot/wt2 && got update > /dev/null)
1536 ret=$?
1537 if [ $ret -ne 0 ]; then
1538 echo "got checkout failed unexpectedly" >&2
1539 test_done "$testroot" "$ret"
1540 return 1
1543 if ! [ -h $testroot/wt2/passwd.link ]; then
1544 echo 'passwd.link is not a symlink' >&2
1545 test_done "$testroot" 1
1546 return 1
1549 readlink $testroot/wt2/passwd.link > $testroot/stdout
1550 echo "alpha" > $testroot/stdout.expected
1551 cmp -s $testroot/stdout.expected $testroot/stdout
1552 ret=$?
1553 if [ $ret -ne 0 ]; then
1554 diff -u $testroot/stdout.expected $testroot/stdout
1555 return 1
1558 test_done "$testroot" "0"
1561 test_commit_prepared_logmsg() {
1562 local testroot=`test_init commit_prepared_logmsg`
1564 got checkout $testroot/repo $testroot/wt > /dev/null
1565 ret=$?
1566 if [ $ret -ne 0 ]; then
1567 test_done "$testroot" "$ret"
1568 return 1
1571 echo "modified alpha" > $testroot/wt/alpha
1572 (cd $testroot/wt && got rm beta >/dev/null)
1573 echo "new file" > $testroot/wt/new
1574 (cd $testroot/wt && got add new >/dev/null)
1576 echo 'test commit_prepared_logmsg' > $testroot/logmsg
1578 cat > $testroot/editor.sh <<EOF
1579 #!/bin/sh
1580 sed -i 's/foo/bar/' "\$1"
1581 EOF
1582 chmod +x $testroot/editor.sh
1584 (cd $testroot/wt && env VISUAL="$testroot/editor.sh" \
1585 got commit -F "$testroot/logmsg" > $testroot/stdout)
1587 local head_rev=`git_show_head $testroot/repo`
1588 echo "A new" > $testroot/stdout.expected
1589 echo "M alpha" >> $testroot/stdout.expected
1590 echo "D beta" >> $testroot/stdout.expected
1591 echo "Created commit $head_rev" >> $testroot/stdout.expected
1593 cmp -s $testroot/stdout.expected $testroot/stdout
1594 ret=$?
1595 if [ $ret -ne 0 ]; then
1596 diff -u $testroot/stdout.expected $testroot/stdout
1597 test_done "$testroot" "$ret"
1598 return 1
1601 local author_time=`git_show_author_time $testroot/repo`
1602 d=`date -u -r $author_time +"%a %b %e %X %Y UTC"`
1603 echo "-----------------------------------------------" > $testroot/stdout.expected
1604 echo "commit $head_rev (master)" >> $testroot/stdout.expected
1605 echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
1606 echo "date: $d" >> $testroot/stdout.expected
1607 echo " " >> $testroot/stdout.expected
1608 echo " test commit_prepared_logmsg" >> $testroot/stdout.expected
1609 echo " " >> $testroot/stdout.expected
1611 (cd $testroot/wt && got log -l 1 > $testroot/stdout)
1612 cmp -s $testroot/stdout.expected $testroot/stdout
1613 ret=$?
1614 if [ $ret -ne 0 ]; then
1615 diff -u $testroot/stdout.expected $testroot/stdout
1616 test_done "$testroot" "$ret"
1617 return 1
1620 echo "modified alpha again" > $testroot/wt/alpha
1622 echo 'test commit_prepared_logmsg non-interactive' \
1623 > $testroot/logmsg
1625 (cd $testroot/wt && got commit -N -F "$testroot/logmsg" \
1626 > $testroot/stdout)
1628 local head_rev=`git_show_head $testroot/repo`
1629 echo "M alpha" > $testroot/stdout.expected
1630 echo "Created commit $head_rev" >> $testroot/stdout.expected
1632 cmp -s $testroot/stdout.expected $testroot/stdout
1633 ret=$?
1634 if [ $ret -ne 0 ]; then
1635 diff -u $testroot/stdout.expected $testroot/stdout
1636 test_done "$testroot" "$ret"
1637 return 1
1640 local author_time=`git_show_author_time $testroot/repo`
1641 d=`date -u -r $author_time +"%a %b %e %X %Y UTC"`
1642 echo "-----------------------------------------------" \
1643 > $testroot/stdout.expected
1644 echo "commit $head_rev (master)" >> $testroot/stdout.expected
1645 echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
1646 echo "date: $d" >> $testroot/stdout.expected
1647 echo " " >> $testroot/stdout.expected
1648 echo " test commit_prepared_logmsg non-interactive" \
1649 >> $testroot/stdout.expected
1650 echo " " >> $testroot/stdout.expected
1652 (cd $testroot/wt && got log -l 1 > $testroot/stdout)
1653 cmp -s $testroot/stdout.expected $testroot/stdout
1654 ret=$?
1655 if [ $ret -ne 0 ]; then
1656 diff -u $testroot/stdout.expected $testroot/stdout
1658 test_done "$testroot" "$ret"
1661 test_commit_large_file() {
1662 local testroot=`test_init commit_large_file`
1664 got checkout $testroot/repo $testroot/wt > /dev/null
1665 ret=$?
1666 if [ $ret -ne 0 ]; then
1667 test_done "$testroot" "$ret"
1668 return 1
1671 dd status=none if=/dev/zero of=$testroot/wt/new bs=1M count=64
1672 (cd $testroot/wt && got add new >/dev/null)
1674 (cd $testroot/wt && got commit -m 'test commit_large_file' \
1675 > $testroot/stdout)
1677 local head_rev=`git_show_head $testroot/repo`
1678 echo "A new" > $testroot/stdout.expected
1679 echo "Created commit $head_rev" >> $testroot/stdout.expected
1681 cmp -s $testroot/stdout.expected $testroot/stdout
1682 ret=$?
1683 if [ $ret -ne 0 ]; then
1684 diff -u $testroot/stdout.expected $testroot/stdout
1685 test_done "$testroot" "$ret"
1686 return 1
1689 new_id=`get_blob_id $testroot/repo "" new`
1690 got cat -r $testroot/repo $new_id > $testroot/new
1691 ret=$?
1692 if [ $ret -ne 0 ]; then
1693 echo "commit failed unexpectedly" >&2
1694 test_done "$testroot" "1"
1695 return 1
1698 cmp -s $testroot/new $testroot/wt/new
1699 ret=$?
1700 if [ $ret -ne 0 ]; then
1701 diff -u $testroot/new $testroot/wt/new
1703 test_done "$testroot" "$ret"
1708 test_commit_gitignore() {
1709 local testroot=`test_init commit_gitignores`
1711 got checkout $testroot/repo $testroot/wt > /dev/null
1712 ret=$?
1713 if [ $ret -ne 0 ]; then
1714 test_done "$testroot" "$ret"
1715 return 1
1718 mkdir -p $testroot/wt/tree1/foo
1719 mkdir -p $testroot/wt/tree2/foo
1720 echo "tree1/**" > $testroot/wt/.gitignore
1721 echo "tree2/**" >> $testroot/wt/.gitignore
1722 echo -n > $testroot/wt/tree1/bar
1723 echo -n > $testroot/wt/tree1/foo/baz
1724 echo -n > $testroot/wt/tree2/bar
1725 echo -n > $testroot/wt/tree2/foo/baz
1726 echo -n > $testroot/wt/epsilon/zeta1
1727 echo -n > $testroot/wt/epsilon/zeta2
1729 (cd $testroot/wt && got add -I -R tree1 > /dev/null)
1730 (cd $testroot/wt && got add -I tree2/foo/baz > /dev/null)
1731 (cd $testroot/wt && got commit -m "gitignore add" > /dev/null)
1732 (cd $testroot/wt && got log -P -l 1 | egrep '^ .' > $testroot/stdout)
1734 echo ' gitignore add' > $testroot/stdout.expected
1735 echo ' A tree1/bar' >> $testroot/stdout.expected
1736 echo ' A tree1/foo/baz' >> $testroot/stdout.expected
1737 echo ' A tree2/foo/baz' >> $testroot/stdout.expected
1739 cmp -s $testroot/stdout.expected $testroot/stdout
1740 ret=$?
1741 if [ $ret -ne 0 ]; then
1742 diff -u $testroot/stdout.expected $testroot/stdout
1743 test_done "$testroot" "$ret"
1744 return 1
1747 echo touch > $testroot/wt/tree1/bar
1748 echo touch > $testroot/wt/tree1/foo/baz
1749 echo touch > $testroot/wt/epsilon/zeta1
1751 (cd $testroot/wt && got commit -m "gitignore change" > /dev/null)
1752 (cd $testroot/wt && got log -P -l 1 | egrep '^ .' > $testroot/stdout)
1754 echo ' gitignore change' > $testroot/stdout.expected
1755 echo ' M tree1/bar' >> $testroot/stdout.expected
1756 echo ' M tree1/foo/baz' >> $testroot/stdout.expected
1758 cmp -s $testroot/stdout.expected $testroot/stdout
1759 ret=$?
1760 if [ $ret -ne 0 ]; then
1761 diff -u $testroot/stdout.expected $testroot/stdout
1762 test_done "$testroot" "$ret"
1763 return 1
1766 test_done "$testroot" "$ret"
1769 test_commit_bad_author() {
1770 local testroot=`test_init commit_bad_author`
1772 got checkout $testroot/repo $testroot/wt > /dev/null
1773 ret=$?
1774 if [ $ret -ne 0 ]; then
1775 test_done "$testroot" $ret
1776 return 1
1779 echo "modified alpha" > $testroot/wt/alpha
1781 (cd $testroot/wt && got commit \
1782 -A "${GIT_AUTHOR_NAME}<${GIT_AUTHOR_EMAIL}>" -m 'edit alpha') \
1783 > /dev/null 2> $testroot/stderr
1784 ret=$?
1785 if [ $ret -eq 0 ]; then
1786 test_done "$testroot" 1
1787 return 1
1790 echo -n "got: ${GIT_AUTHOR_NAME}<${GIT_AUTHOR_EMAIL}>: " \
1791 > $testroot/stderr.expected
1792 echo -n 'space between author name and email required: ' \
1793 >> $testroot/stderr.expected
1794 echo 'commit author formatting would make Git unhappy' \
1795 >> $testroot/stderr.expected
1796 cmp -s $testroot/stderr.expected $testroot/stderr
1797 ret=$?
1798 if [ $ret -ne 0 ]; then
1799 diff -u $testroot/stderr.expected $testroot/stderr
1800 test_done "$testroot" $ret
1801 return 1
1804 test_done "$testroot" 0
1807 test_commit_logmsg_ref() {
1808 local testroot=`test_init commit_logmsg_ref`
1810 got checkout $testroot/repo $testroot/wt > /dev/null
1811 ret=$?
1812 if [ $ret -ne 0 ]; then
1813 test_done "$testroot" "$ret"
1814 return 1
1817 (cd $testroot/repo && git checkout -q -b newbranch)
1819 local bo_logmsg_prefix="log message of backed-out commit"
1820 local cy_logmsg_prefix="log message of cherrypicked commit"
1821 local branch_rev_logmsg="changes on newbranch to cherrypick"
1822 local branch_rev2_logmsg="modified zeta on newbranch to cherrypick"
1824 echo "modified delta on branch" > $testroot/repo/gamma/delta
1825 echo "modified alpha on branch" > $testroot/repo/alpha
1826 (cd $testroot/repo && git rm -q beta)
1827 echo "new file on branch" > $testroot/repo/epsilon/new
1828 (cd $testroot/repo && git add epsilon/new)
1830 git_commit $testroot/repo -m "$branch_rev_logmsg"
1831 local branch_rev=`git_show_head $testroot/repo`
1833 echo "modified zeta on branch" > $testroot/repo/epsilon/zeta
1835 git_commit $testroot/repo -m "$branch_rev2_logmsg"
1836 local branch_rev2=`git_show_head $testroot/repo`
1838 (cd $testroot/wt && got cherrypick $branch_rev > /dev/null)
1839 (cd $testroot/wt && got cherrypick $branch_rev2 > /dev/null)
1841 cat > $testroot/editor.sh <<EOF
1842 #!/bin/sh
1843 sed -i 's/# l/l/' "\$1"
1844 EOF
1845 chmod +x $testroot/editor.sh
1847 (cd $testroot/wt && env VISUAL="$testroot/editor.sh" \
1848 got commit > /dev/null)
1849 ret=$?
1850 if [ $ret -ne 0 ]; then
1851 echo "'got commit' failed unexpectedly" >&2
1852 test_done "$testroot" "1"
1853 return 1
1856 # check that multiple cherrypicked log messages populate the editor
1857 local first=`printf '%s\n%s' $branch_rev $branch_rev2 | sort | head -1`
1858 local second=`printf '%s\n%s' $branch_rev $branch_rev2 | sort | tail -1`
1860 if [ $branch_rev == $first ]; then
1861 local first_msg=$branch_rev_logmsg
1862 local second_msg=$branch_rev2_logmsg
1863 else
1864 local first_msg=$branch_rev2_logmsg
1865 local second_msg=$branch_rev_logmsg
1868 echo " $cy_logmsg_prefix $first:" > $testroot/stdout.expected
1869 echo " $first_msg" >> $testroot/stdout.expected
1870 echo " " >> $testroot/stdout.expected
1871 echo " $cy_logmsg_prefix $second:" >> $testroot/stdout.expected
1872 echo " $second_msg" >> $testroot/stdout.expected
1873 echo " " >> $testroot/stdout.expected
1875 (cd $testroot/wt && got log -l2 | \
1876 grep -A2 'log message' | sed '/^--/d' > $testroot/stdout)
1878 cmp -s $testroot/stdout.expected $testroot/stdout
1879 ret=$?
1880 if [ $ret -ne 0 ]; then
1881 diff -u $testroot/stdout.expected $testroot/stdout
1882 test_done "$testroot" "$ret"
1883 return 1
1886 # check that only the relevant log message populates the editor
1887 # when the changes from one of two backout commits are reverted
1888 got checkout $testroot/repo $testroot/wt2 > /dev/null
1889 ret=$?
1890 if [ $ret -ne 0 ]; then
1891 test_done "$testroot" "$ret"
1892 return 1
1895 (cd $testroot/wt2 && got backout $branch_rev > /dev/null)
1896 (cd $testroot/wt2 && got backout $branch_rev2 > /dev/null)
1897 (cd $testroot/wt2 && got revert epsilon/zeta > /dev/null)
1899 (cd $testroot/wt2 && env VISUAL="$testroot/editor.sh" \
1900 got commit > /dev/null)
1901 ret=$?
1902 if [ $ret -ne 0 ]; then
1903 echo "'got commit' failed unexpectedly" >&2
1904 test_done "$testroot" "1"
1905 return 1
1908 echo " $bo_logmsg_prefix $branch_rev:" > $testroot/stdout.expected
1909 echo " $branch_rev_logmsg" >> $testroot/stdout.expected
1910 echo " " >> $testroot/stdout.expected
1912 (cd $testroot/wt2 && got log -l1 | \
1913 grep -A2 'log message' > $testroot/stdout)
1915 cmp -s $testroot/stdout.expected $testroot/stdout
1916 ret=$?
1917 if [ $ret -ne 0 ]; then
1918 diff -u $testroot/stdout.expected $testroot/stdout
1919 test_done "$testroot" "$ret"
1920 return 1
1923 # check that a cherrypicked log message is still
1924 # used when its changes are only partially reverted
1925 branch_rev_logmsg="changes to cherrypick and partially revert"
1927 echo "newline in alpha" >> $testroot/repo/alpha
1928 echo "modified epsilon/zeta on branch" > $testroot/repo/epsilon/zeta
1930 git_commit $testroot/repo -m "$branch_rev_logmsg"
1931 branch_rev=`git_show_head $testroot/repo`
1933 (cd $testroot/wt && got cherrypick $branch_rev > /dev/null)
1934 (cd $testroot/wt && got revert alpha > /dev/null)
1936 (cd $testroot/wt && env VISUAL="$testroot/editor.sh" \
1937 got commit > /dev/null)
1938 ret=$?
1939 if [ $ret -ne 0 ]; then
1940 echo "'got commit' failed unexpectedly" >&2
1941 test_done "$testroot" "1"
1942 return 1
1945 echo " $cy_logmsg_prefix $branch_rev:" > $testroot/stdout.expected
1946 echo " $branch_rev_logmsg" >> $testroot/stdout.expected
1947 echo " " >> $testroot/stdout.expected
1949 (cd $testroot/wt && got log -l1 | \
1950 grep -A2 'log message' > $testroot/stdout)
1952 cmp -s $testroot/stdout.expected $testroot/stdout
1953 ret=$?
1954 if [ $ret -ne 0 ]; then
1955 diff -u $testroot/stdout.expected $testroot/stdout
1956 test_done "$testroot" "$ret"
1957 return 1
1960 # check we don't use and consequently delete the logmsg ref of a
1961 # cherrypicked commit when omitting its changed path from the commit
1962 branch_rev_logmsg="changes to cherrypick but omit from the commit"
1964 echo "changed delta" >> $testroot/repo/gamma/delta
1966 git_commit $testroot/repo -m "$branch_rev_logmsg"
1967 local author_time=`git_show_author_time $testroot/repo`
1968 local d=`date -u -r $author_time +"%a %b %e %X %Y UTC"`
1969 branch_rev=`git_show_head $testroot/repo`
1971 (cd $testroot/wt && got update > /dev/null)
1972 ret=$?
1973 if [ $ret -ne 0 ]; then
1974 echo "got update failed unexpectedly" >&2
1975 test_done "$testroot" "$ret"
1976 return 1
1979 (cd $testroot/wt && got cherrypick $branch_rev > /dev/null)
1981 echo "changed alpha" >> $testroot/wt/alpha
1983 (cd $testroot/wt && got commit -m \
1984 "don't commit cy change to gamma/delta" alpha > /dev/null)
1985 ret=$?
1986 if [ $ret -ne 0 ]; then
1987 echo "'got commit' failed unexpectedly" >&2
1988 test_done "$testroot" "1"
1989 return 1
1992 # confirm logmsg ref was not deleted with got cherrypick -l
1993 echo "-----------------------------------------------" \
1994 > $testroot/stdout.expected
1995 echo "cherrypick $branch_rev (newbranch)" >> $testroot/stdout.expected
1996 echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
1997 echo "date: $d" >> $testroot/stdout.expected
1998 echo " " >> $testroot/stdout.expected
1999 echo " $branch_rev_logmsg" >> $testroot/stdout.expected
2000 echo " " >> $testroot/stdout.expected
2001 echo " M gamma/delta" >> $testroot/stdout.expected
2002 echo >> $testroot/stdout.expected
2004 (cd $testroot/wt && got cherrypick -l > $testroot/stdout)
2006 cmp -s $testroot/stdout.expected $testroot/stdout
2007 ret=$?
2008 if [ $ret -ne 0 ]; then
2009 diff -u $testroot/stdout.expected $testroot/stdout
2010 test_done "$testroot" "$ret"
2011 return 1
2014 # confirm a previously unused logmsg ref is picked up
2015 # when an affected path is actually committed
2016 (cd $testroot/wt && env VISUAL="$testroot/editor.sh" \
2017 got commit > /dev/null)
2018 ret=$?
2019 if [ $ret -ne 0 ]; then
2020 echo "'got commit' failed unexpectedly" >&2
2021 test_done "$testroot" "1"
2022 return 1
2025 echo " $cy_logmsg_prefix $branch_rev:" > $testroot/stdout.expected
2026 echo " $branch_rev_logmsg" >> $testroot/stdout.expected
2027 echo " " >> $testroot/stdout.expected
2029 (cd $testroot/wt && got log -l1 | \
2030 grep -A2 'log message' > $testroot/stdout)
2032 cmp -s $testroot/stdout.expected $testroot/stdout
2033 ret=$?
2034 if [ $ret -ne 0 ]; then
2035 diff -u $testroot/stdout.expected $testroot/stdout
2036 test_done "$testroot" "$ret"
2037 return 1
2040 # make sure we are not littering work trees
2041 # by leaving temp got-logmsg-* files behind
2042 echo -n > $testroot/stdout.expected
2043 (cd $testroot/wt && got status > $testroot/stdout)
2045 cmp -s $testroot/stdout.expected $testroot/stdout
2046 ret=$?
2047 if [ $ret -ne 0 ]; then
2048 echo "$testroot/wt is not clean"
2049 diff -u $testroot/stdout.expected $testroot/stdout
2050 test_done "$testroot" "$ret"
2051 return 1
2054 (cd $testroot/wt2 && got status > $testroot/stdout)
2056 cmp -s $testroot/stdout.expected $testroot/stdout
2057 ret=$?
2058 if [ $ret -ne 0 ]; then
2059 echo "$testroot/repo is not clean"
2060 diff -u $testroot/stdout.expected $testroot/stdout
2062 test_done "$testroot" "$ret"
2065 test_parseargs "$@"
2066 run_test test_commit_basic
2067 run_test test_commit_new_subdir
2068 run_test test_commit_subdir
2069 run_test test_commit_single_file
2070 run_test test_commit_out_of_date
2071 run_test test_commit_added_subdirs
2072 run_test test_commit_deleted_subdirs
2073 run_test test_commit_rejects_conflicted_file
2074 run_test test_commit_single_file_multiple
2075 run_test test_commit_added_and_modified_in_same_dir
2076 run_test test_commit_path_prefix
2077 run_test test_commit_dir_path
2078 run_test test_commit_selected_paths
2079 run_test test_commit_outside_refs_heads
2080 run_test test_commit_no_email
2081 run_test test_commit_tree_entry_sorting
2082 run_test test_commit_cmdline_author
2083 run_test test_commit_gotconfig_author
2084 run_test test_commit_gotconfig_worktree_author
2085 run_test test_commit_gitconfig_author
2086 run_test test_commit_xbit_change
2087 run_test test_commit_normalizes_filemodes
2088 run_test test_commit_with_unrelated_submodule
2089 run_test test_commit_symlink
2090 run_test test_commit_fix_bad_symlink
2091 run_test test_commit_prepared_logmsg
2092 run_test test_commit_large_file
2093 run_test test_commit_gitignore
2094 run_test test_commit_bad_author
2095 run_test test_commit_logmsg_ref